var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useState, useCallback, useEffect } from 'react';
import classnames from 'classnames';
import _ from 'lodash';
import loadingSVG from './loading';
var isTwoChinese = function (str) { return /^[\u4e00-\u9fa5]{2}$/.test(str); };
var nullFn = function () { };
var active = _.throttle(function (setClassNames) {
    setClassNames(function (classNames) {
        setTimeout(function () {
            setClassNames(function (clsNames) {
                return clsNames.split(' ').filter(function (item) { return item !== 'mute-btn-active'; }).join(' ');
            });
        }, 800);
        return classNames + ' mute-btn-active';
    });
}, 800);
var Button = function (props) {
    var _a = props.children, children = _a === void 0 ? 'Button' : _a, _b = props.size, size = _b === void 0 ? 'md' : _b, _c = props.type, type = _c === void 0 ? 'default' : _c, _d = props.disabled, disabled = _d === void 0 ? false : _d, _e = props.htmlType, htmlType = _e === void 0 ? 'button' : _e, _f = props.block, block = _f === void 0 ? false : _f, icon = props.icon, loading = props.loading, _g = props.onClick, onClick = _g === void 0 ? nullFn : _g;
    var _h = useState(classnames({
        'mute-btn': true,
        'mute-btn-small': size === 'sm',
        'mute-btn-large': size === 'lg',
        'mute-btn-danger': type === 'danger',
        'mute-btn-success': type === 'success',
        'mute-btn-warning': type === 'warning',
        'mute-btn-primary': type === 'primary',
        'mute-btn-default': type === 'default',
        'mute-btn-link': type === 'link',
        'mute-btn-block': block,
        'mute-btn-loading': type === 'link' ? false : loading,
    })), classNames = _h[0], setClassNames = _h[1];
    useEffect(function () {
        if (loading) {
            setClassNames(function (classNames) { return classNames + ' mute-btn-loading'; });
        }
        else {
            setClassNames(function (clsNames) { return clsNames.split(' ').filter(function (item) { return item !== 'mute-btn-loading'; }).join(' '); });
        }
    }, [loading]);
    var showActive = useCallback(function () {
        !loading && active(setClassNames);
    }, [loading]);
    var text = '';
    if (typeof children === 'string' && isTwoChinese(children)) {
        text = children[0] + ' ' + children[1];
    }
    return (_jsx("button", __assign({ className: classNames, disabled: disabled, onClick: disabled || loading ? nullFn : onClick, onMouseUp: disabled ? nullFn : showActive, type: htmlType }, { children: _jsxs("span", __assign({ className: "mute-btn-text" }, { children: [(icon || loading) && (_jsx("span", __assign({ className: "mute-btn-icon" }, { children: _jsx("i", { children: loading && type !== 'link' ?
                            loadingSVG()
                            : icon }, void 0) }), void 0)),
                _jsx("span", { children: text || children }, void 0)] }), void 0) }), void 0));
};
export default Button;
