var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { forwardRef, useCallback, useImperativeHandle, useRef, useState } from 'react';
import classnames from 'classnames';
var Input = forwardRef(function (props, cref) {
    var _a = props.placeholder, placeholder = _a === void 0 ? '' : _a, _b = props.size, size = _b === void 0 ? 'md' : _b, _c = props.defaultValue, defaultValue = _c === void 0 ? '' : _c, value = props.value, _d = props.className, className = _d === void 0 ? '' : _d, style = props.style, _e = props.allowClear, allowClear = _e === void 0 ? false : _e, onChange = props.onChange;
    var classNames = classnames({
        "mute-input-basic": true,
        "mute-input-basic-lg": size === 'lg',
        "mute-input-basic-sm": size === 'sm',
    });
    var ref = useRef(null);
    var _f = useState(value), val = _f[0], setVal = _f[1];
    useImperativeHandle(cref, function () {
        ref.current.value = val === undefined ? defaultValue : val;
        return ref.current;
    }, [val, defaultValue]);
    var handleChange = useCallback(function (evt) {
        queueMicrotask(function () {
            onChange && onChange(evt);
            setVal(evt.target.value);
        });
    }, [onChange]);
    var handleClear = useCallback(function () {
        ref.current.value = '';
        ref.current.focus();
        setVal('');
    }, []);
    return (_jsxs("div", __assign({ className: "mute-input-basic-wrapper" }, { children: [allowClear && (_jsx("span", __assign({ onClick: handleClear, style: { display: val ? "block" : "none" }, className: "mute-input-clear" }, { children: "X" }), void 0)),
            _jsx("input", { style: style, className: classNames + ' ' + className, type: "text", placeholder: placeholder, defaultValue: defaultValue, onChange: handleChange, ref: ref }, void 0)] }), void 0));
});
export default Input;
